<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Terminy\Listeners\Udalost;

use App\Models\Pouzivatel\Pouzivatel;
use App\Models\Pracovisko\Pracovisko;
use Illuminate\Support\Facades\Notification;
use Seka\Portal\Modul\Terminy\Entities\Dtos\Factory\UdalostDTOFactory;
use Seka\Portal\Modul\Terminy\Events\Udalost\UdalostBolaZrusena;
use Seka\Portal\Modul\Terminy\Notifications\Udalost\ZrusenaUdalostNotifikaciaDB;
use Seka\Portal\Modul\Terminy\Notifications\Udalost\ZrusenaUdalostNotifikaciaMail;

/**
 * Class OdoslatNotifikacieOZrusenejUdalosti
 *
 * @package Seka\Portal\Modul\Terminy\Listeners\Udalost
 */
final class OdoslatNotifikacieOZrusenejUdalosti
{
    /**
     * @param \Seka\Portal\Modul\Terminy\Events\Udalost\UdalostBolaZrusena $event
     */
    public function handle(UdalostBolaZrusena $event)
    {
        $udalost = UdalostDTOFactory::make($event->udalost);

        Notification::send(
            Pouzivatel::query()->aktivny()->get(),
            new ZrusenaUdalostNotifikaciaDB($udalost)
        );

        Notification::send(
            Pracovisko::query()->get(),
            new ZrusenaUdalostNotifikaciaMail($udalost)
        );
    }
}
